<?php
/**
 * Plugin Name:			Briefcasewp Extras
 * Plugin URI:			http://briefcasewp.com/bew-extras
 * Description:			Extra features for Briefcase Elementor Widgets.
 * Version:				2.4.3
 * Author:				briefcaseWP
 * Author URI:			http://briefcasewp.com
 * Requires at least:	4.9.0
 * Tested up to:		6.0.2
 *
 * Text Domain: bew-extras
 * Domain Path: /languages/
 *
 * @package bew-extras
 * @category Core
 * @author Briefcasewp
 */

if ( ! defined( 'ABSPATH' ) ) exit; // Exit if accessed directly

$options = get_site_option('briefcase-elementor-widgets_updater_options');
$email= isset($options['email']) ? $options['email'] : '';		
$check_password = !empty(isset($options['password'])) ? "yes" : "no";
	
if ($check_password == "no"){
	$option_bew_extras = get_site_option('bew_extras_options');
	$check_password_confirm = !empty(isset($option_bew_extras['confirm_password'])) ? "yes" : "no";
}

if ($email != '' && $check_password == "yes" ){ 		
	require 'includes/plugin-update-checker/plugin-update-checker.php';
		$myUpdateChecker = Puc_v4_Factory::buildUpdateChecker(
		'https://briefcasewp.com/?udm_action=updateinfo&slug=briefcasewp-extras&muid=1',
		__FILE__,
		'briefcasewp-extras'
	);
}

define( 'BEW_EXTRAS_VERSION', '2.4.3' );
define( 'BEW_EXTRAS_PREVIOUS_STABLE_VERSION', '2.4.2' );

define( 'BEW_EXTRAS__FILE__', __FILE__ );
define( 'BEW_EXTRAS_PLUGIN_BASE', plugin_basename( BEW_EXTRAS__FILE__ ) );
define( 'BEW_EXTRAS_PATH', plugin_dir_path( BEW_EXTRAS__FILE__ ) );
define( 'BEW_EXTRAS_MODULES_PATH', BEW_EXTRAS_PATH . 'modules/' );
define( 'BEW_EXTRAS_URL', plugins_url( '/', BEW_EXTRAS__FILE__ ) );
define( 'BEW_EXTRAS_ASSETS_URL', BEW_EXTRAS_URL . 'assets/' );
define( 'BEW_EXTRAS_MODULES_URL', BEW_EXTRAS_URL . 'modules/' );
define( 'BEW_EXTRAS_NAME', 'Briefcase Extras' );
define( 'BEW_EXTRAS_IMPORTER_ASSETS_URL', BEW_EXTRAS_URL . 'extensions/bew-importer/assets/' );
define( 'BEW_EXTRAS_EXTENSIONS_ASSETS_URL', BEW_EXTRAS_URL . 'extensions/bew-extensions/assets/' );
define( 'BEW_EXTRAS_EXTENSIONS_PATH', BEW_EXTRAS_PATH . 'extensions/bew-extensions/extensions/' );
define( 'BEW_EXTRAS_EXTENSIONS_URL', BEW_EXTRAS_URL . 'extensions/bew-extensions/extensions/' );
/**
 * Load gettext translate for our text domain.
 *
 * @since 1.0.0
 *
 * @return void
 */
function bew_extras_load_plugin() {
	load_plugin_textdomain( 'bew-extras', false, dirname( plugin_basename( __FILE__ ) ) . '/languages/' );

	require( BEW_EXTRAS_PATH . 'plugin.php' );
}
add_action( 'plugins_loaded', 'bew_extras_load_plugin' );

if ( ! function_exists( 'bew_is_plugin_active' ) ) {
	
function bew_is_plugin_active() {
		$file_path = 'elementor/elementor.php';
		$installed_plugins = get_plugins();

		return isset( $installed_plugins[ $file_path ] );
}
}
	
if ( ! function_exists( 'bew_is_elementor_installed' ) ) {

function bew_is_elementor_installed() {
		$file_path = 'elementor/elementor.php';
		$installed_plugins = get_plugins();

		return isset( $installed_plugins[ $file_path ] );
}
}

/**
* A shorthand function to get an image uri from /assets/img/ directory.
*/
function bew_get_img_uri( $path ) {
	return BEW_EXTRAS_URL . 'extensions/bew-builder/assets/img/'. $path ;
}

/**
 * Get blog posts page URL.
 *
 * @return string The blog posts page URL.
 */
function bew_get_blog_posts_page_url() {

	// If front page is set to display a static page, get the URL of the posts page.
	if ( 'page' === get_option( 'show_on_front' ) ) {
		return get_permalink( get_option( 'page_for_posts' ) );
	}

	// The front page IS the posts page. Get its URL.
	return get_home_url();
}
